package cn.wps.moffice.secondary.aidl.engine;

import cn.wps.moffice.secondary.aidl.ui.Slide;
import cn.wps.moffice.secondary.aidl.engine.SlimResults;

interface Document {
	void save(String filepath, int format);
	int getSlideCount();	
	Slide slideAt(int index);
	boolean isReadOnly();
	
	// 开始瘦身
    SlimResults slim();
    
    // 检查瘦身
    SlimResults checkSlim();
    
    /**
     * 提取幻灯片
     *
     * @param targetPath 被提取的幻灯片路径
     * @param targets 被提取幻灯片的索引。从0开始
     * @param savePath 提取成功后，生成文档的路径
     */
    boolean extract(String targetPath, in int[] targets, String savePath);
    
    /**
     * 合拼演示文档
     * 
     * @param savePath 合拼后，生成文档的位置
     * @param targets 待合拼的演示文档路径集合
     * @param writePasswds 待合拼的演示文档的编辑密码集合
     * @param readPasswds 待合拼的演示文档的写密码集合
     */
    boolean merge(String savePath, in List<String> targets, in List<String> writePasswds, in List<String> readPasswds);
}